/*
 * Title            :  GBBJob.java
 * Package      	:  examples
 * Project        	:  Gridbus Broker
 * Description   	:		
 * Created on   	:  March 31, 2005
 * Author	     	:  Hussein Gibbins (hag@cs.mu.oz.au)
 * Copyright     	:   (c) 2005, Grid Computing and Distributed Systems Laboratory, 
 * 					   Dept. of Computer Science and Software Engineering,
 * 					   University of Melbourne, Australia.
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later  version.
 * See the GNU General Public License (http://www.gnu.org/copyleft/gpl.html)for more details.
 * 
 */
package org.gridbus.broker.examples.portlets.gridbusbroker;

import java.io.IOException;
import java.util.Iterator;
import java.util.Vector;

import javax.portlet.ActionRequest;
import javax.portlet.ActionResponse;
import javax.portlet.GenericPortlet;
import javax.portlet.PortletException;
import javax.portlet.PortletSession;
import javax.portlet.RenderRequest;
import javax.portlet.RenderResponse;

import org.gridbus.broker.farming.common.GridbusFarmingEngine;
import org.gridbus.broker.farming.common.Job;
import org.ietf.jgss.GSSCredential;
import org.ietf.jgss.GSSException;


/**
 * This portlet allows you to execute a command over the grid using the Gridbus Broker.
 * 
 * Here we make use of the broker's API functionality to create jobs and then submit them
 * onto the Grid.  The main code for starting up the broker and the jobs here is quite 
 * simple and is easily modified to suit your own needs.
 *
 */
public class GBBJob extends GenericPortlet {
	
     /**
     * @see javax.portlet.GenericPortlet#processAction(javax.portlet.ActionRequest, javax.portlet.ActionResponse)
     */
    public void processAction(ActionRequest req, ActionResponse res) throws PortletException, IOException {
    }

    /**
     * Set up any required view parameters.
     * @param request
     * @param response
     * @throws PortletException
     * @throws IOException
     */
    public void doView(RenderRequest request, RenderResponse response) throws PortletException, IOException {

		//PrintStream ps=new PrintStream(new FileOutputStream("c:\\jobinfodebug"));  //debugging

    	// get session
        PortletSession session = request.getPortletSession(true);
        GSSCredential credential = (GSSCredential) session.getAttribute("userCred");
        String user = "";
        if (credential != null) {
        	try {
        		user = credential.getName().toString();
        	} catch (GSSException e) {
            	e.printStackTrace();
            } 
        	
        	GridbusFarmingEngine fe = (GridbusFarmingEngine)session.getAttribute("fe");
        	String jid = (String)session.getAttribute("jid");
        	//ps.println("jid="+jid);
        	if (fe!=null){
        		Vector jobs = (Vector)fe.getJobs();
        		if (jobs!=null && jid!=null){
        			for (Iterator it=jobs.iterator();it.hasNext();){
        				Job j = (Job)it.next();
        				if (j.getJobID().equals(jid)){
        					request.setAttribute("job",j);
        					break;
        				}
        			}
        		}
        	}else{
        	    //ps.println("doView fe is null");
        	}
        }
        
        //if (request.getAttribute("job")==null)
            //ps.println("doView...job is null");
        //else
            //ps.println("doView...job is NOT null");
        
        //ps.close();
        
        request.setAttribute("userCredName", user);
        request.setAttribute("url", response.createActionURL().toString());
        
        getPortletContext().getRequestDispatcher("/jsp/job.jsp").include(request, response);
    }
}
