package plan2run.GBJobs;

import java.io.*;

/**
 * Title: GridBus Parameterization Toolkit
 * Description:
 * Copyright: Copyright (c) 2002
 * Company: GRIDS Lab University of Melbourne
 * author: Steve Melnikoff, Shoaib Burq
 * version 1.0
 */

public class Jobs
{

	protected String jobStr = "";
	protected String columnBuffer = "  ";
	protected int fieldSize = 7; 

	//Main methods
	public Jobs(int N, int[] R)
	{
		// The job list is stored in this String


		
		jobStr = "\n"+"indexcount " + N + "\n" + "jobs" + "\n";
		// Initialise COUNTERS
		int C[] = new int[N];

		for (int i = 0; i < N; i++)
			C[i] = 0;

		// Initialise Job ID
		int JC = 1;

		// Special case when N=1
		if (N == 1)
		{
			for (int j = 0; j < R[0]; j++)
			{
				jobStr = jobStr + JC + "  " + j + "\n";
				JC++;
			}
		} else
		{
			// Printing Jobs with Parameter Index Values
			while (C[N - 1] != R[N - 1])
				// Do until the last counter reaches its maximum
			{
				// Print JobID + parameter indices: JOBID index_range1; index_range2;....
				jobStr = jobStr + JC;
				for (int i = 0; i < N; i++)
				{
					jobStr = jobStr  + "  " + C[i];
				}
				jobStr = jobStr + "\n";

				//Increase Job ID;
				JC++;

				// Increase 1st Counter and Initialise Carry Forward
				C[0]++;
				int CF; // Carry Forward
				if (C[0] == R[0]) 	// 1st counter completed one cycle
				{
					C[0] = 0;
					CF = 1;
				} else
					CF = 0;
				// Update Remaining Counters Except last one
				for (int i = 1; i < N - 1; i++)
				{
					C[i] += CF;
					if (C[i] == R[i])
					{
						C[i] = 0;
						CF = 1;
					} else
						CF = 0;
				}
				// Update the Last Counter
				C[N - 1] += CF;
			}
		}
		jobStr = jobStr + "endjobs\n";
	}

	protected String getBuffer(int jc)
	{
	/*	int digits = (jc / 10)+1;
		System.out.println("digits = " + digits);
		int empty = columnBuffer.length() - digits;
		System.out.println("empty= " + empty);
		int i = 0;
		if (empty >= 0) 
			i = (columnBuffer.length() + empty);
	*/	String emptySpace= " ";
		/*while (i<0)
		{	
			emptySpace += " "; i--;	
		}
		System.out.println("*" + emptySpace + "*");*/
		return emptySpace;
	}	

	public String getJobStr()	{ return jobStr; }

	public static void main(String[] args)
	{
		int N = 4;
		int R[] = new int[N];
		R[0] = 2;
		R[1] = 3;
		R[2] = 4;
		R[3] = 1;
		Jobs jobs = new Jobs(N, R);
		System.out.println(jobs.getJobStr());
	}
}
